package us.kostenko.gps_service_plugin.utils

import android.content.Context
import android.os.Build
import java.text.SimpleDateFormat
import java.util.Date
import java.util.Locale


const val defaultFormat = "yyyy-MM-dd'T'HH:mm:ssZ"

fun Long.toDateString(context: Context, pattern: String = defaultFormat): String = SimpleDateFormat(pattern, context.currentLocale)
        .format(Date(this))

val Context.currentLocale: Locale
    get() = if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
        resources.configuration.locales.get(0)
    } else {
        resources.configuration.locale
    }