package us.kostenko.gps_service_plugin_example

import timber.log.Timber
import us.kostenko.gps_service_plugin.utils.TimberInitializer

object TimberInitializerImpl: TimberInitializer {

    override fun init() {
        Timber.plant(object: Timber.DebugTree() {

            override fun createStackElementTag(element: StackTraceElement): String? {
                return String.format("Timber(%s:%s:%s)",
                                     super.createStackElementTag(element),
                                     element.methodName,
                                     element.lineNumber)
            }
        })
    }
}