package us.kostenko.gps_service_plugin_example

import android.util.Log.DEBUG
import android.util.Log.INFO
import android.util.Log.VERBOSE
import timber.log.Timber
import us.kostenko.gps_service_plugin.utils.TimberInitializer

object TimberInitializerImpl: TimberInitializer {

    override fun init() {
        Timber.plant(CrashReportingTree())
    }

    /** A tree which logs important information for crash reporting.  */
    private class CrashReportingTree : Timber.Tree() {
        override fun log(priority: Int, tag: String?, message: String, t: Throwable?) {
            if (priority == VERBOSE || priority == DEBUG) {
                return
            }
        }

        override fun isLoggable(tag: String?, priority: Int) = priority >= INFO
    }
}